<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();
require_once("lib/alipay_submit.class.php");
require_once("lib/alipay_notify.class.php");
class PayplansAppAlipay extends PayplansAppPayment
{
	protected $_location	= __FILE__;
	
	function isApplicable($refObject = null, $eventName='')
	{
		// return true for event onPayplansControllerCreation
		if($eventName == 'onPayplansControllerCreation'){
			return true;
		}
		
		return parent::isApplicable($refObject, $eventName);
	}
	
	function onPayplansControllerCreation($view, $controller, $task, $format)
	{
		// out_trade_no should be present in data posted
		// it will be payment key
		if($view == 'payment' && $task == 'notify'){
			$key = JRequest::getVar('out_trade_no', false);
			JRequest::setVar('payment_key', $key, 'POST');
			return true;
		}
		
		return true;
	}
	
    function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		if(is_object($data)){
			$data = (array)$data;
		}
		
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);

		$partner 		= $this->getAppParam('partner','');
		$out_trade_no	= $payment->getKey();
		$subject		= $invoice->getTitle();
		$body			= $invoice->getTitle();
		$total_fee		= $invoice->getTotal();
		$currency		= $invoice->getCurrency('isocode');
		$seller_email	= $this->getAppParam('seller_email');
		$this->assign('key', $this->getAppParam('private_key',''));
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
    	
    	$notify_url = $root.'index.php?option=com_payplans&gateway=alipay&view=payment&task=notify';
		$return_url = $root.'index.php?option=com_payplans&view=payment&task=complete';
		
        
        //防钓鱼时间戳
        $anti_phishing_key = "";
        //若要使用请调用类文件submit中的query_timestamp函数

        //客户端的IP地址
        $exter_invoke_ip = "";
		
		$alipay_config['partner']		= $this->getAppParam('partner','');
		$alipay_config['key']			= $this->getAppParam('private_key','');
		$alipay_config['sign_type']    	= strtoupper('MD5');

		$alipay_config['input_charset']	= strtolower('utf-8');
		$alipay_config['cacert']    	= getcwd().'\\cacert.pem';
		$alipay_config['transport']    	= XiFactory::getConfig()->https?'https':'http';
		
		$parameter 			= array(
								"service" 			=> "create_direct_pay_by_user",
								"partner" 			=> trim($alipay_config['partner']),
								"payment_type"		=> "1",
								"notify_url"		=> $notify_url,
								"return_url"		=> $return_url,
								"seller_email"		=> $seller_email,
								"out_trade_no"		=> $out_trade_no,
								"subject"			=> $subject,
								"total_fee"			=> $total_fee,
								"body"				=> $body,
								"show_url"			=> $show_url,
								"anti_phishing_key"	=> $anti_phishing_key,
								"exter_invoke_ip"	=> $exter_invoke_ip,
								"_input_charset"	=> trim(strtolower($alipay_config['input_charset']))
							);


		//建立请求
		$alipaySubmit 	= new AlipaySubmit($alipay_config);
		$html_text 		= $alipaySubmit->buildRequestForm($parameter,"get", "Confirm");
		$this->assign('html_text', $html_text);
		
		return $this->_render('form_subscription');
	}


	function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{
		$invoice 		= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', 			$payment->getBuyer())
					->set('invoice_id', 		$invoice->getId())
					->set('payment_id', 		$payment->getId())
					->set('gateway_txn_id', 	isset($data['trade_no']) ? $data['trade_no'] : 0)
					->set('gateway_subscr_id', 	isset($data['out_trade_no']) ? $data['out_trade_no'] : 0)
					->set('params', 			PayplansHelperParam::arrayToIni($data));

		$alipay_config['partner']			= $this->getAppParam('partner','');
		$alipay_config['key']				= $this->getAppParam('private_key','');
		$alipay_config['sign_type']    		= strtoupper('MD5');

		$alipay_config['input_charset']		= strtolower('utf-8');
		$alipay_config['cacert']    		= getcwd().'\\cacert.pem';
		$alipay_config['transport']    		= XiFactory::getConfig()->https?'https':'http';
					
		$alipayNotify 	= new AlipayNotify($alipay_config);
		$verify_result 	= $alipayNotify->verifyNotify();
		if($verify_result) {
			$out_trade_no = $data['out_trade_no'];
			//支付宝交易号
			$trade_no = $data['trade_no'];
			//交易状态
			$trade_status = $data['trade_status'];
	 		if($trade_status == 'TRADE_FINISHED'|| $data['trade_status'] == 'TRADE_SUCCESS') {
				$transaction->set('amount',$data['total_fee'])
							->set('message', 'COM_PAYPLANS_APP_ALIPAY_SUCCESS')
							->save();	
    		} 		
		}
		else {
	 	 $errors[] = XiText::_('COM_PAYPLANS_APP_ALIPAY_FAIL');
		 $transaction->set('message', 'COM_PAYPLANS_APP_ALIPAY_FAIL')
								->save();
		return $errors;
	    }
		
		// if same notification came more than one time
    	// check if transaction already exists
    	// if yes then do nothing and return
    	$txn_id 	=  0;
    	$subscr_id  = isset($data['out_trade_no']) ? $data['out_trade_no'] : 0;
    	
    	$transactions = $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, 0);
    	if($transactions !== false){
    		foreach($transactions as $transaction){
    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			if($transaction->getParam('trade_no','') == $data['trade_no']){
    				return true;
    			}
    		}
    	}

		$transaction->save();
		return $errors;
	}
	
    public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
		$logs 	= PayplansHelperLogger::getLog($payment, XiLogger::LEVEL_ERROR);
		$record = array_pop($logs);			
		if($record && !empty($record)){
			$action = 'error';
		}
		
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}

}
